package com.duanledexianxianxian.demo;

import com.duanledexianxianxian.demo.util.ExcelWaterRemarkUtils;
import com.duanledexianxianxian.demo.util.ImageUtils;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.*;

/**
 * Hello world!
 *
 */
public class App 
{
    public static void main( String[] args ) throws IOException {
        //读取excel文件
        Workbook wb = new XSSFWorkbook(new FileInputStream("F:\\@project@\\@dianli@\\java-demo\\excel-watermark\\src\\main\\resources\\test.xlsx"));
        //设置水印图片路径
        String imgPath = "F:\\@project@\\@dianli@\\java-demo\\excel-watermark\\src\\main\\resources\\水印.png";
        ImageUtils.createWaterMark("文字水印效果", imgPath);
        //获取excel sheet个数
        int sheets = wb.getNumberOfSheets();
        //循环sheet给每个sheet添加水印
        for (int i = 0; i < sheets; i++) {
            Sheet sheet = wb.getSheetAt(i);
            //excel加密只读
            //sheet.protectSheet(UUID.randomUUID().toString());
            //获取excel实际所占行
            int row = sheet.getFirstRowNum() + sheet.getLastRowNum();
            //获取excel实际所占列
            int cell = sheet.getRow(sheet.getFirstRowNum()).getLastCellNum() + 1;
            //根据行与列计算实际所需多少水印
            ExcelWaterRemarkUtils.putWaterRemarkToExcel(wb, sheet, imgPath, 0, 0, 5, 5, cell / 5 + 1, row / 5 + 1, 0, 0);
        }
        ByteArrayOutputStream os = new ByteArrayOutputStream();
        try {
            wb.write(os);
        } catch (IOException e) {
            e.printStackTrace();
        }
        wb.close();
        byte[] content = os.toByteArray();
        // Excel文件生成后存储的位置。
        File file1 = new File("F:\\@project@\\@dianli@\\java-demo\\excel-watermark\\src\\main\\resources\\watermark.xlsx");
        OutputStream fos = null;
        try {
            fos = new FileOutputStream(file1);
            fos.write(content);
            os.close();
            fos.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
